module LabGUI
using WebIO, InteractNext
include("gridmaker.jl")
include("gui.jl")
include("construct.jl")
include("svg_helper.jl")


#We redefine WebIO.newid to prevent nodes from getting infinitely high values,
# and Base.show is redefined to prevent memory leaks when constructing SVGs
const max_nodes = 100000
let count=1
    global newid
    node_space=Dict()
    function WebIO.newid(prefix)
        if count == max_nodes
            count = 0
        end
        string(prefix, "-", count+=1)
    end
end

function Base.show(io::IO, m::MIME"text/html", x::Node)
    if haskey(x.props, :id)
        id = "$(x.props[:id])-parent"
    else
        id = WebIO.newid("node")
    end
    x in keys(WebIO.showcbs) && (x = WebIO.showcbs[x](id))
    write(io, """<div id=$id></div>
          <script>WebIO.mount('$id', '#$id',""")
    WebIO.jsexpr(io, x)
    write(io, ")</script>")
end
end
